/[gentoo-x86]/eclass/elisp-common.eclass
Gentoo

Diff of /eclass/elisp-common.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.7 Revision 1.31
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.7 2004/06/25 00:39:48 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.31 2007/12/01 15:35:02 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
5# Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org> 6# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org>
7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org>
6# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 8# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
9# Copyright 2007 Ulrich Mueller <ulm@gentoo.org>
7# 10#
8# This is not an eclass, but it does provide emacs-related 11# @ECLASS: elisp-common.eclass
9# installation utilities. 12# @MAINTAINER:
13# Feel free to contact the Emacs team through <emacs@gentoo.org> if you have
14# problems, suggestions or questions.
15# @BLURB: Emacs-related installation utilities
16# @DESCRIPTION:
17#
18# Usually you want to use this eclass for (optional) GNU Emacs support of
19# your package. This is NOT for XEmacs!
20#
21# Many of the steps here are sometimes done by the build system of your
22# package (especially compilation), so this is mainly for standalone elisp
23# files you gathered from somewhere else.
24#
25# When relying on the emacs USE flag, you need to add
26#
27# emacs? ( virtual/emacs )
28#
29# to your DEPEND/RDEPEND line and use the functions provided here to bring
30# the files to the correct locations.
31#
32# .SS
33# src_compile() usage:
34#
35# An elisp file is compiled by the elisp-compile() function defined here and
36# simply takes the source files as arguments.
37#
38# elisp-compile *.el || die "elisp-compile failed"
39#
40# In the case of interdependent elisp files, you can use the elisp-comp()
41# function which makes sure all files are loadable.
42#
43# elisp-comp *.el || die "elisp-comp failed"
44#
45# Function elisp-make-autoload-file() can be used to generate a file with
46# autoload definitions for the lisp functions. It takes the output file name
47# (default: "${PN}-autoloads.el") and a list of directories (default: working
48# directory) as its arguments. Use of this function requires that the elisp
49# source files contain magic ";;;###autoload" comments. See the Emacs Lisp
50# Reference Manual (node "Autoload") for a detailed explanation.
51#
52# .SS
53# src_install() usage:
54#
55# The resulting compiled files (.elc) should be put in a subdirectory of
56# /usr/share/emacs/site-lisp/ which is named after the first argument
57# of elisp-install(). The following parameters are the files to be put in
58# that directory. Usually the subdirectory should be ${PN}, you can choose
59# something else, but remember to tell elisp-site-file-install() (see below)
60# the change, as it defaults to ${PN}.
61#
62# elisp-install ${PN} *.el *.elc || die "elisp-install failed"
63#
64# To let the Emacs support be activated by Emacs on startup, you need
65# to provide a site file (shipped in ${FILESDIR}) which contains the startup
66# code (have a look in the documentation of your software). Normally this
67# would look like this:
68#
69# ;;; csv-mode site-lisp configuration
70#
71# (add-to-list 'load-path "@SITELISP@")
72# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode))
73# (autoload 'csv-mode "csv-mode" "Major mode for csv files." t)
74#
75# If your Emacs support files are installed in a subdirectory of
76# /usr/share/emacs/site-lisp/ (which is recommended), you need to extend
77# Emacs' load-path as shown in the first non-comment.
78# The elisp-site-file-install() function of this eclass will replace
79# "@SITELISP@" by the actual path.
80#
81# The next line tells Emacs to load the mode opening a file ending with
82# ".csv" and load functions depending on the context and needed features.
83# Be careful though. Commands as "load-library" or "require" bloat the
84# editor as they are loaded on every startup. When having a lot of Emacs
85# support files, users may be annoyed by the start-up time. Also avoid
86# keybindings as they might interfere with the user's settings. Give a hint
87# in pkg_postinst(), which should be enough.
88#
89# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the
90# two digits at the beginning define the loading order. So if you depend on
91# another Emacs package, your site file's number must be higher!
92#
93# Best practice is to define a SITEFILE variable in the global scope of your
94# ebuild (right after DEPEND e.g.):
95#
96# SITEFILE=50${PN}-gentoo.el
97#
98# Which is then installed by
99#
100# elisp-site-file-install "${FILESDIR}/${SITEFILE}" || die
101#
102# in src_install(). If your subdirectory is not named ${PN}, give the
103# differing name as second argument.
104#
105# .SS
106# pkg_postinst() / pkg_postrm() usage:
107#
108# After that you need to recreate the start-up file of Emacs after emerging
109# and unmerging by using
110#
111# pkg_postinst() {
112# elisp-site-regen
113# }
114#
115# pkg_postrm() {
116# elisp-site-regen
117# }
118#
119# When having optional Emacs support, you should prepend "use emacs &&" to
120# above calls of elisp-site-regen(). Don't use "has_version virtual/emacs"!
121# When unmerging the state of the emacs USE flag is taken from the package
122# database and not from the environment, so it is no problem when you unset
123# USE=emacs between merge and unmerge of a package.
124#
125# .SS
126# Miscellaneous functions:
127#
128# elisp-emacs-version() outputs the version of the currently active Emacs.
10 129
11ECLASS=elisp-common 130# @ECLASS-VARIABLE: SITELISP
12INHERITED="$INHERITED $ECLASS" 131# @DESCRIPTION:
13 132# Directory where packages install Emacs Lisp files.
14SITELISP=/usr/share/emacs/site-lisp 133SITELISP=/usr/share/emacs/site-lisp
15 134
135# Directory where packages install miscellaneous (not Lisp) files.
136SITEETC=/usr/share/emacs/etc
137
138# @ECLASS-VARIABLE: SITEFILE
139# @DESCRIPTION:
140# Name of package's site-init file.
141SITEFILE=50${PN}-gentoo.el
142
143EMACS=/usr/bin/emacs
144# The following works for Emacs versions 18--23, don't change it.
145EMACSFLAGS="-batch -q --no-site-file"
146
147# @FUNCTION: elisp-compile
148# @USAGE: <list of elisp files>
149# @DESCRIPTION:
150# Byte-compile Emacs Lisp files.
151
16elisp-compile() { 152elisp-compile() {
17 /usr/bin/emacs --batch -f batch-byte-compile --no-site-file --no-init-file $* 153 einfo "Compiling GNU Emacs Elisp files ..."
154 ${EMACS} ${EMACSFLAGS} -f batch-byte-compile "$@"
18} 155}
156
157# @FUNCTION: elisp-comp
158# @USAGE: <list of elisp files>
159# @DESCRIPTION:
160# Byte-compile interdependent Emacs Lisp files.
161#
162# This function byte-compiles all ".el" files which are part of its
163# arguments, using GNU Emacs, and puts the resulting ".elc" files into the
164# current directory, so disregarding the original directories used in ".el"
165# arguments.
166#
167# This function manages in such a way that all Emacs Lisp files to be
168# compiled are made visible between themselves, in the event they require or
169# load one another.
170
171elisp-comp() {
172 # Copyright 1995 Free Software Foundation, Inc.
173 # François Pinard <pinard@iro.umontreal.ca>, 1995.
174 # Originally taken from GNU autotools.
175
176 [ $# -gt 0 ] || return 1
177
178 einfo "Compiling GNU Emacs Elisp files ..."
179
180 tempdir=elc.$$
181 mkdir ${tempdir}
182 cp "$@" ${tempdir}
183 pushd ${tempdir}
184
185 echo "(add-to-list 'load-path \"../\")" > script
186 ${EMACS} ${EMACSFLAGS} -l script -f batch-byte-compile *.el
187 local ret=$?
188 mv *.elc ..
189
190 popd
191 rm -fr ${tempdir}
192 return ${ret}
193}
194
195# @FUNCTION: elisp-emacs-version
196# @DESCRIPTION:
197# Output version of currently active Emacs.
198
199elisp-emacs-version() {
200 # The following will work for at least versions 18-23.
201 echo "(princ emacs-version)" >"${T}"/emacs-version.el
202 ${EMACS} ${EMACSFLAGS} -l "${T}"/emacs-version.el
203}
204
205# @FUNCTION: elisp-make-autoload-file
206# @USAGE: [output file] [list of directories]
207# @DESCRIPTION:
208# Generate a file with autoload definitions for the lisp functions.
209
210elisp-make-autoload-file() {
211 local f="${1:-${PN}-autoloads.el}"
212 shift
213 einfo "Generating autoload file for GNU Emacs ..."
214
215 sed 's/^FF/\f/' >"${f}" <<-EOF
216 ;;; ${f##*/} --- autoloads for ${P}
217
218 ;;; Commentary:
219 ;; Automatically generated by elisp-common.eclass
220 ;; DO NOT EDIT THIS FILE
221
222 ;;; Code:
223 FF
224 ;; Local Variables:
225 ;; version-control: never
226 ;; no-byte-compile: t
227 ;; no-update-autoloads: t
228 ;; End:
229 ;;; ${f##*/} ends here
230 EOF
231
232 ${EMACS} ${EMACSFLAGS} \
233 --eval "(setq make-backup-files nil)" \
234 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \
235 -f batch-update-autoloads "${@-.}"
236}
237
238# @FUNCTION: elisp-install
239# @USAGE: <subdirectory> <list of files>
240# @DESCRIPTION:
241# Install files in SITELISP directory.
19 242
20elisp-install() { 243elisp-install() {
21 local subdir=$1 244 local subdir="$1"
22 dodir ${SITELISP}/${subdir}
23 insinto ${SITELISP}/${subdir}
24 shift 245 shift
246 einfo "Installing Elisp files for GNU Emacs support ..."
247 ( # subshell to avoid pollution of calling environment
248 insinto "${SITELISP}/${subdir}"
25 doins $@ 249 doins "$@"
250 )
26} 251}
252
253# @FUNCTION: elisp-site-file-install
254# @USAGE: <site-init file> [subdirectory]
255# @DESCRIPTION:
256# Install Emacs site-init file in SITELISP directory.
27 257
28elisp-site-file-install() { 258elisp-site-file-install() {
29 local sitefile=$1 my_pn=${2:-${PN}} 259 local sf="$1" my_pn="${2:-${PN}}"
30 pushd ${S} 260 einfo "Installing site initialisation file for GNU Emacs ..."
31 cp ${sitefile} ${T} 261 cp "${sf}" "${T}"
32 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" ${T}/$(basename ${sitefile}) 262 sed -i -e "s:@SITELISP@:${SITELISP}/${my_pn}:g" \
263 -e "s:@SITEETC@:${SITEETC}/${my_pn}:g" "${T}/${sf##*/}"
264 ( # subshell to avoid pollution of calling environment
33 insinto ${SITELISP} 265 insinto "${SITELISP}"
34 doins ${T}/$(basename ${sitefile}) 266 doins "${T}/${sf##*/}"
35 popd 267 )
36} 268}
269
270# @FUNCTION: elisp-site-regen
271# @DESCRIPTION:
272# Regenerate site-gentoo.el file.
37 273
38elisp-site-regen() { 274elisp-site-regen() {
275 local sflist sf line
276
277 if [ ! -e "${ROOT}${SITELISP}"/site-gentoo.el ] \
278 && [ ! -e "${ROOT}${SITELISP}"/site-start.el ]; then
279 einfo "Creating default ${SITELISP}/site-start.el ..."
280 cat <<-EOF >"${T}"/site-start.el
281 ;;; site-start.el
282
283 ;;; Commentary:
284 ;; This default site startup file is installed by elisp-common.eclass.
285 ;; You may replace this file by your own site initialisation, or even
286 ;; remove it completely; it will not be recreated.
287
288 ;;; Code:
289 ;; Load site initialisation for Gentoo-installed packages.
290 (require 'site-gentoo)
291
292 ;;; site-start.el ends here
293 EOF
294 fi
295
39 einfo "Regenerating ${SITELISP}/site-gentoo.el..." 296 einfon "Regenerating ${SITELISP}/site-gentoo.el ..."
40 einfo ""
41 cat <<EOF >${SITELISP}/site-gentoo.el 297 cat <<-EOF >"${T}"/site-gentoo.el
42;;; DO NOT EDIT THIS FILE -- IT IS GENERATED AUTOMATICALLY BY PORTAGE 298 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages
43;;; -----------------------------------------------------------------
44 299
300 ;;; Commentary:
301 ;; Automatically generated by elisp-common.eclass
302 ;; DO NOT EDIT THIS FILE
303
304 ;;; Code:
305 EOF
306
307 for sf in "${ROOT}${SITELISP}"/[0-9][0-9]*-gentoo.el
308 do
309 [ -r "${sf}" ] || continue
310 sflist="${sflist} ${sf##*/}"
311 cat "${sf}" >>"${T}"/site-gentoo.el
312 done
313
314 cat <<-EOF >>"${T}"/site-gentoo.el
315
316 (provide 'site-gentoo)
317
318 ;; Local Variables:
319 ;; no-byte-compile: t
320 ;; End:
321 ;;; site-gentoo.el ends here
322 EOF
323
324 if cmp -s "${ROOT}${SITELISP}"/site-gentoo.el "${T}"/site-gentoo.el; then
325 # This prevents outputting unnecessary text when there
326 # was actually no change.
327 # A case is a remerge where we have doubled output.
328 echo " no changes."
329 else
330 mv "${T}"/site-gentoo.el "${ROOT}${SITELISP}"/site-gentoo.el
331 [ -f "${T}"/site-start.el ] \
332 && [ ! -e "${ROOT}${SITELISP}"/site-start.el ] \
333 && mv "${T}"/site-start.el "${ROOT}${SITELISP}"/site-start.el
334 echo; einfo
335 for sf in ${sflist}; do
336 einfo " Adding ${sf} ..."
337 done
338 while read line; do einfo "${line}"; done <<EOF
339
340All site initialisation for Gentoo-installed packages is added to
341/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
342managed by Gentoo. You are responsible for all maintenance of
343site-start.el if there is such a file.
344
345In order for this site initialisation to be loaded for all users
346automatically, you can add a line like this:
347
348 (require 'site-gentoo)
349
350to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
351can be added by individual users to their initialisation files, or,
352for greater flexibility, users can load individual package-specific
353initialisation files from /usr/share/emacs/site-lisp/.
45EOF 354EOF
46 ls ${SITELISP}/[0-9][0-9]*-gentoo.el |sort -n | \
47 while read sf
48 do
49 einfo " Adding $(basename $sf)..."
50 # Great for debugging, too noisy and slow for users though
51# echo "(message \"Loading $sf...\")" >>${SITELISP}/site-start.el
52 cat $sf >>${SITELISP}/site-gentoo.el
53 done
54 while read line; do einfo "${line}"; done <<EOF
55
56All site initialization for Gentoo-installed packages is now added to
57/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
58managed by Gentoo. You may want to remove the generated
59site-start.el.
60
61In order for this site initialization to be loaded for all users
62automatically, as was done previously, you can add a line like this:
63
64 (load "/usr/share/emacs/site-lisp/site-gentoo")
65
66to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
67can be added by individual users to their initialization files, or for
68greater flexibility, users can select which of the package-specific
69initialization files in /usr/share/emacs/site-lisp to load.
70EOF
71 echo 355 echo
72}
73
74# The following Emacs Lisp compilation routine is taken from GNU
75# autotools.
76
77elisp-comp() {
78# Copyright 1995 Free Software Foundation, Inc.
79# François Pinard <pinard@iro.umontreal.ca>, 1995.
80#
81# This program is free software; you can redistribute it and/or modify
82# it under the terms of the GNU General Public License as published by
83# the Free Software Foundation; either version 2, or (at your option)
84# any later version.
85#
86# This program is distributed in the hope that it will be useful,
87# but WITHOUT ANY WARRANTY; without even the implied warranty of
88# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
89# GNU General Public License for more details.
90#
91# You should have received a copy of the GNU General Public License
92# along with this program; if not, write to the Free Software
93# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
94
95# As a special exception to the GNU General Public License, if you
96# distribute this file as part of a program that contains a
97# configuration script generated by Autoconf, you may include it under
98# the same distribution terms that you use for the rest of that program.
99
100# This script byte-compiles all `.el' files which are part of its
101# arguments, using GNU Emacs, and put the resulting `.elc' files into
102# the current directory, so disregarding the original directories used
103# in `.el' arguments.
104#
105# This script manages in such a way that all Emacs LISP files to
106# be compiled are made visible between themselves, in the event
107# they require or load-library one another.
108
109 if test $# = 0; then
110 echo 1>&2 "No files given to $0"
111 exit 1
112 else
113 if test -z "$EMACS" || test "$EMACS" = "t"; then
114 # Value of "t" means we are running in a shell under Emacs.
115 # Just assume Emacs is called "emacs".
116 EMACS=emacs
117 fi
118
119 tempdir=elc.$$
120 mkdir $tempdir
121 cp $* $tempdir
122 cd $tempdir
123
124 echo "(add-to-list 'load-path \"../\")" > script
125 $EMACS -batch -q --no-site-file --no-init-file -l script -f batch-byte-compile *.el
126 mv *.elc ..
127
128 cd ..
129 rm -fr $tempdir
130 fi 356 fi
131} 357}
132
133# Local Variables: ***
134# mode: shell-script ***
135# tab-width: 4 ***
136# indent-tabs-mode: t ***
137# End: ***
138

Legend:
Removed from v.1.7  
changed lines
  Added in v.1.31

  ViewVC Help
Powered by ViewVC 1.1.20